
        .XCREF
        .NOLIST
        INCLUDE \masm32\include\masm32rt.inc
        .LIST

;###################################################################################

ConOut  PROTO   :DWORD,:DWORD

;###################################################################################

        .DATA

MsgStr  db 'Enter an Empty String to Exit',13,10
MsgInp  db ' Input: '
MsgOut  db 'Output: '

OfsCrLf EQU offset MsgStr+sizeof MsgStr-2

;***********************************************************************************

        .DATA?

hStdInp dd ?
hStdOut dd ?
InpBuf  db 256 dup(?)

;###################################################################################

        .CODE

_main   PROC

;----------------------------------------------

;initialization

        INVOKE  GetStdHandle,STD_OUTPUT_HANDLE
        mov     hStdOut,eax
        INVOKE  GetStdHandle,STD_INPUT_HANDLE
        mov     hStdInp,eax
        INVOKE  SetConsoleMode,eax,
                ENABLE_LINE_INPUT or ENABLE_ECHO_INPUT or ENABLE_PROCESSED_INPUT

;----------------------------------------------

;display message

        call    NewLine
        INVOKE  ConOut,offset MsgStr,sizeof MsgStr
        call    NewLine

;----------------------------------------------

;input/output loop

        jmp short loop01

loop00: push    eax                                 ;ConOut:dwLen
        push    edx                                 ;ConOut:lpString
        INVOKE  ConOut,offset MsgOut,sizeof MsgOut
        CALL    ConOut
        call    NewLine
        call    NewLine

loop01: INVOKE  ConOut,offset MsgInp,sizeof MsgInp
        call    ConInp
        or      eax,eax
        jnz     loop00

;----------------------------------------------

;terminate

        INVOKE  ExitProcess,0

_main   ENDP

;***********************************************************************************

ConOut  PROC    lpString:DWORD,dwLen:DWORD

        push    eax
        mov     eax,esp
        INVOKE  WriteFile,hStdOut,lpString,dwLen,eax,NULL
        pop     eax
        ret

ConOut  ENDP

;***********************************************************************************

ConInp  PROC

        mov     edx,offset InpBuf
        push    edx
        push    eax
        mov     eax,esp
        INVOKE  ReadFile,hStdInp,edx,sizeof InpBuf,eax,NULL
        pop     eax
        pop     edx
        dec     eax
        mov     ecx,edx
        add     ecx,eax
        mov byte ptr [ecx],0
        dec     eax
        ret

ConInp  ENDP

;***********************************************************************************

NewLine PROC

        INVOKE  ConOut,OfsCrLf,2
        ret

NewLine ENDP

;###################################################################################

        END     _main

